Unit adg1r_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, AFG1R_p;

procedure adg1r(var A :Array of Real; var D1 :Real; var D2 :Integer;
                var S :Array of Integer; var N :Integer); 
implementation

procedure adg1r(var A :Array of Real; var D1 :Real; var D2 :Integer;
                var S :Array of Integer; var N :Integer);
var
I :Integer;
label
_1,_2,_3,_4,_5,_6;
begin
AFG1R(A,S,N);
S[N-1] := N;
D1 := 1.0;
D2 := 0;
for I:=1 to N do
 begin
  D1 := D1*A[(I-1)+(I-1)*N];
  if ( D1 = 0.0 ) 
   then goto _5;
_1:
  if ( Abs(D1) < 1.0 ) 
   then goto _2;
  D1 := D1*0.0625;
  D2 := D2+4;
  goto _1;
_2:
  if ( Abs(D1) >= 0.0625 ) 
   then goto _3;
  D1 := D1*16.0;
  D2 := D2-4;
  goto _2;
_3:
 end;
for I:=1 to N do
 begin
  if ( S[I-1] <> I ) 
   then D1 := -D1;
_4:
 end;
goto _6;
_5:
D1 := 0.0;
D2 := 0;
_6:
end;

end.
